
; Messages
CM_ADDCOL          equ WM_USER+1  ; wParam=0, lParam=lpCOLUMN
CM_ADDROW          equ WM_USER+2  ; wParam=0, lParam=lpROWDATA (can be NULL)
CM_SETCURSEL       equ WM_USER+3  ; wParam=nCol, lParam=nRow
CM_GETCURCOL       equ WM_USER+4  ; wParam=0, lParam=0
CM_GETCURROW       equ WM_USER+5  ; wParam=0, lParam=0
CM_GETCELLDATA     equ WM_USER+6  ; wParam=nRowCol, lParam=lpData
CM_SETCELLDATA     equ WM_USER+7  ; wParam=nRowCol, lParam=lpData
CM_GETCELLRECT     equ WM_USER+8  ; wParam=nRowCol, lParam=lpRECT
CM_SCROLLLIST      equ WM_USER+9  ; wParam=0, lParam=0
CM_ENTEREDIT       equ WM_USER+10 ; wParam=nCol, lParam=nRow
CM_ENDEDIT         equ WM_USER+11 ; wParam=nRowCol, lParam=fCancel
CM_GETCOLWIDTH     equ WM_USER+12 ; wParam=nCol, lParam=0
CM_SETCOLWIDTH     equ WM_USER+13 ; wParam=nCol, lParam=nWidth
CM_GETHDRHEIGHT    equ WM_USER+14 ; wParam=0, lParam=0
CM_SETHDRHEIGHT    equ WM_USER+15 ; wParam=0, lParam=nHeight
CM_GETROWHEIGHT    equ WM_USER+16 ; wParam=0, lParam=0
CM_SETROWHEIGHT    equ WM_USER+17 ; wParam=0, lParam=nHeight
CM_RESETCONTENT    equ WM_USER+18 ; wParam=0, lParam=0
CM_COLUMNSORT      equ WM_USER+19 ; wParam=nCol, lParam=0=Ascending, 1=Descending, 2=Invert
CM_GETHDRTEXT      equ WM_USER+20 ; wParam=nCol, lParam=lpBuffer
CM_SETHDRTEXT      equ WM_USER+21 ; wParam=nCol, lParam=lpszText
CM_GETCOLTYPE      equ WM_USER+22 ; wParam=nCol, lParam=0
CM_SETHANDLES      equ WM_USER+23 ; wParam=0, lParam=lpHandles
CM_SETCOLORS       equ WM_USER+24 ; wParam=0, lParam=lpColors
CM_SETFONTS        equ WM_USER+25 ; wParam=hFontC, lParam=hFontL
CM_SETGRIDLINES    equ WM_USER+26 ; wParam=TRUE/FALSE, lParam=0
CM_SETACTIVE       equ WM_USER+27 ; wParam=0, lParam=TRUE/FALSE
CM_DBCLICK         equ WM_USER+28 ; wParam=nCol, lParam=nRow
CM_GETSORT         equ WM_USER+29 ; wParam=0, lParam=0
CM_GETSCROLLPOS    equ WM_USER+30 ; wParam=0, lParam=0
CM_SETSCROLLPOS    equ WM_USER+31 ; wParam=0, lParam=0
CM_CHECKSELECT     equ WM_USER+32 ; wParam=0, lParam=0
CM_LEFTWIDTH       equ WM_USER+33 ; wParam=nWidth, lParam=0
CM_SENDDRAG        equ WM_USER+34 ; wParam=0, lParam=0
CM_SENDDROP        equ WM_USER+35 ; wParam=0, lParam=0
CM_GETSUMCOLWIDTH  equ WM_USER+36 ; wParam=0, lParam=0
CM_SETSELECTALL    equ WM_USER+37 ; wParam=0, lParam=0
CM_CLEARSELECT     equ WM_USER+38 ; wParam=0, lParam=0
CM_INVERTSELECT    equ WM_USER+39 ; wParam=0, lParam=0
CM_CLEAREDIT       equ WM_USER+40 ; wParam=0, lParam=0
CM_REDRAW          equ WM_USER+41 ; wParam=0, lParam=0 +66
CM_SETTREE         equ WM_USER+42 ; wParam=0, lParam=TRUE/FALSE
CM_SETTREEMODE     equ WM_USER+43 ; wParam=0, lParam=TRUE/FALSE

CN_HEADERCLICK     equ 1          ; User clicked header
CN_BUTTONCLICK     equ 2          ; Sent when user clicks the button in a button cell
CN_CHECKCLICK      equ 3          ; Sent when user double clicks the checkbox in a checkbox cell
CN_IMAGECLICK      equ 4          ; Sent when user double clicks the image in an image cell
CN_BEFORESELCHANGE equ 5          ; Sent when user request a selection change
CN_AFTERSELCHANGE  equ 6          ; Sent after a selection change
CN_BEFOREEDIT      equ 7          ; Sent before the cell edit control shows
CN_AFTEREDIT       equ 8          ; Sent when the cell edit control is about to close
CN_BEFOREUPDATE    equ 9          ; Sent before a cell updates grid data
CN_AFTERUPDATE     equ 10         ; Sent after grid data has been updated
CN_USERCONVERT     equ 11         ; Sent when user cell needs to be converted.
CN_DRAG            equ 12         ; Sent when user starts a drag drop
CN_DRAGDROP        equ 13         ; Sent when user completes a drag drop
CN_SETACTIVE       equ 14         ; Sent when user clicks within a listview

; Column alignment
ALIGN_LEFT         equ 0
ALIGN_CENTER       equ 1
ALIGN_RIGHT        equ 2

; Column types
TYPE_EDITTEXT      equ 0          ; String
TYPE_EDITLONG      equ 1          ; Long

; Column sorting
SORT_ASCENDING     equ 0
SORT_DESCENDING    equ 1
SORT_INVERT        equ 2

; Window styles
STYLE_NOSEL        equ 01h
STYLE_NOFOCUS      equ 02h
STYLE_HGRIDLINES   equ 04h
STYLE_VGRIDLINES   equ 08h
STYLE_GRIDFRAME    equ 10h

.const
CListClass     db  'CListClass',0

.data?
Test4          dd  ?
Test5          dd  ?
Test6          dd  ?

; Column structure
COLUMN struct
   lpszPath    dd  ?               ; Pointer to list path text.
   ColWth      dd  ?               ; Column width.
   lpszhdrtext dd  ?               ; Pointer to header text.
   HeaderAlign dd  ?               ; Header text alignment.
   ColumnAlign dd  ?               ; Column text alignment.
   ColumnType  dd  ?               ; Column data type.
   MaxLen      dd  ?               ; Max text lenght for TYPE_EDITTEXT and TYPE_EDITLONG.
   lpszFormat  dd  ?               ; Format string for TYPE_EDITLONG.
   hImageList  dd  ?               ; Handle of image list. For the image columns and combobox only.
   SortFlag    dd  ?               ; Sort flags.
   SortAD      dd  ?               ; Sort ascending decending.
   ColNum      dd  ?               ; Column number
   Colxp       dd  ?               ; Column position. Internally used.
   EditWnd     dd  ?               ; Column control handle. Internally used.
COLUMN ends

; Notifications
LISTNOTIFY struct
   nmhdr       NMHDR <?>
   Col         dd  ?               ; Column
   Row         dd  ?               ; Row
   hwnd        dd  ?               ; Handle of the column edit control
   hList       dd  ?               ; Handle of the active list control
   DragOn      dd  ?               ; Start drag
   HitList     dd  ?               ; Left or Right list
   HitRow      dd  ?               ; Target row
   RButt       dd  ?               ; Right button down
   DBClick     dd  ?               ; Left button double click
   FileTyp     dd  ?               ; File type e.g. GoBack. Dir, File
   SortFlag    dd  ?               ; Sort flags.
   lpdata      dd  ?               ; Pointer to data
   fcancel     dd  ?               ; Set to TRUE to cancel operation
LISTNOTIFY ends

