
MEM_SIZE       equ 128*1024

.code

ExpandMem PROC uses esi edi hMem1:DWORD, nSize
LOCAL    hMem2:DWORD

         mov     eax, nSize
         add     eax, MEM_SIZE
      INVOKE     GlobalAlloc, GMEM_MOVEABLE, eax
         mov     hMem2, eax
      INVOKE     GlobalLock, hMem2
         mov     edi, eax
      INVOKE     GlobalLock, hMem1
         mov     esi, eax
         mov     ecx, nSize
         shr     ecx, 2
         rep     movsd
      INVOKE     GlobalUnlock, hMem1
      INVOKE     GlobalFree, hMem1
         xor     eax, eax
         mov     ecx, MEM_SIZE/4
       stosd
      INVOKE     GlobalUnlock, hMem2
         mov     eax, hMem2
         ret

ExpandMem ENDP

ListGetText PROC uses ebx edi hMem:DWORD, rpData, lpData

         mov     ebx, hMem
      .if rpData
         INVOKE     GlobalLock, [ebx].LIST.hString
            mov     edi, eax
            add     edi, rpData
         INVOKE     lstrcpy, lpData, edi
         INVOKE     GlobalUnlock, [ebx].LIST.hString
      .else
            mov     edi, lpData
            mov     byte ptr [edi], 0
      .endif
         ret
      
ListGetText ENDP

ListGetFixed PROC uses ebx esi edi hMem:DWORD, rpData, lpData, len

      mov     ebx, hMem
      .if rpData
         INVOKE     GlobalLock, [ebx].LIST.hString
            mov     esi, eax
            add     esi, rpData
            mov     edi, lpData
            mov     ecx, len
            rep     movsb
         INVOKE     GlobalUnlock, [ebx].LIST.hString
      .else
            xor     eax, eax
            mov     edi, lpData
            mov     ecx, len
            rep     stosb
      .endif
         ret

ListGetFixed ENDP

ListAddText PROC uses ebx edi hMem:DWORD, lpData
LOCAL    len:DWORD

         mov     ebx, hMem
      INVOKE     lstrlen, lpData
         inc     eax
         mov     len, eax
      .if ![ebx].LIST.hString
         INVOKE     GlobalAlloc, GMEM_MOVEABLE or GMEM_ZEROINIT, MEM_SIZE
            mov     [ebx].LIST.hString, eax
            mov     [ebx].LIST.rpStrFree, 1
            mov     [ebx].LIST.StrMemSize, MEM_SIZE
      .endif
         mov     eax, [ebx].LIST.rpStrFree
        push     eax
         add     eax, len
      .if eax > [ebx].LIST.StrMemSize
         INVOKE     ExpandMem, [ebx].LIST.hString, [ebx].LIST.StrMemSize
            mov     [ebx].LIST.hString, eax
            add     [ebx].LIST.StrMemSize, MEM_SIZE
      .endif
      INVOKE     GlobalLock, [ebx].LIST.hString
         mov     edi, eax
         add     edi, [ebx].LIST.rpStrFree
      INVOKE     lstrcpy, edi, lpData
         mov     eax, len
         add     [ebx].LIST.rpStrFree, eax
      INVOKE     GlobalUnlock, [ebx].LIST.hString
         pop     eax
         ret

ListAddText ENDP

ListAddFixed PROC uses ebx esi edi hMem:DWORD, lpData, len

         mov     ebx, hMem
      .if ![ebx].LIST.hString
         INVOKE     GlobalAlloc, GMEM_MOVEABLE or GMEM_ZEROINIT, MEM_SIZE
            mov     [ebx].LIST.hString, eax
            mov     [ebx].LIST.rpStrFree, 1
            mov     [ebx].LIST.StrMemSize, MEM_SIZE
      .endif
         mov     eax, [ebx].LIST.rpStrFree
        push     eax
         add      eax, len
      .if eax > [ebx].LIST.StrMemSize
         INVOKE     ExpandMem, [ebx].LIST.hString, [ebx].LIST.StrMemSize
            mov     [ebx].LIST.hString, eax
            add     [ebx].LIST.StrMemSize, MEM_SIZE
      .endif
      INVOKE     GlobalLock, [ebx].LIST.hString
         mov     edi, eax
         add     edi, [ebx].LIST.rpStrFree
         mov     esi, lpData
         mov     ecx, len
         rep     movsb
         mov     eax, len
         add     [ebx].LIST.rpStrFree, eax
      INVOKE     GlobalUnlock, [ebx].LIST.hString
         pop     eax
         ret

ListAddFixed ENDP

ListAddLong PROC uses ebx edi hMem:DWORD, nData

         mov     ebx, hMem
      .if ![ebx].LIST.hMem
         INVOKE     GlobalAlloc, GMEM_MOVEABLE or GMEM_ZEROINIT, MEM_SIZE
            mov     [ebx].LIST.hMem, eax
            mov     [ebx].LIST.rpMemFree, 0
            mov     [ebx].LIST.MemSize, MEM_SIZE
      .endif
         mov     eax, [ebx].LIST.rpMemFree
         add     eax, 4
      .if eax > [ebx].LIST.MemSize
         INVOKE     ExpandMem, [ebx].LIST.hMem, [ebx].LIST.MemSize
            mov     [ebx].LIST.hMem, eax
            add     [ebx].LIST.MemSize, MEM_SIZE
      .endif
      INVOKE     GlobalLock, [ebx].LIST.hMem
         mov     edi, eax
         add     edi, [ebx].LIST.rpMemFree
         mov     eax, nData
         mov     [edi], eax
         add     [ebx].LIST.rpMemFree, 4
      INVOKE     GlobalUnlock, [ebx].LIST.hMem
         ret

ListAddLong ENDP

ListAddRowData PROC uses ebx esi edi hMem:DWORD, lpData

         mov     ebx, hMem
        push     [ebx].LIST.rpMemFree
         mov     esi, lpData
         lea     edi, [ebx+sizeof LIST]
      .if esi
;            inc     [ebx].LIST.ActRows
      .endif
         xor     ecx, ecx
      .while ecx < [ebx].LIST.Cols
           push     ecx
            mov     eax, [edi].COLUMN.ColumnType
         .if eax == TYPE_EDITTEXT
               xor     eax, eax
            .if esi
                  mov     eax, [esi]
               INVOKE     ListAddText, ebx, eax
            .endif
         .else
               xor     eax, eax
            .if esi
                  mov     eax, [esi]
            .endif
         .endif
         INVOKE     ListAddLong, ebx, eax
         .if esi
               add     esi, 4
         .endif
            add     edi, sizeof COLUMN
            pop     ecx
            inc     ecx
      .endw
         pop     eax
         ret
      
ListAddRowData ENDP

ListGetCellData PROC uses ebx esi edi hMem:DWORD, rpData, nCol, lpData

         mov     ebx, hMem
      INVOKE     GlobalLock, [ebx].LIST.hMem
         mov     esi, eax
         add     esi, rpData
         mov     eax, nCol
         lea     esi, [esi+eax*4]
         mov     edx, sizeof COLUMN
         mul     edx
         lea     edi, [ebx+eax+sizeof LIST]
         mov     eax, [edi].COLUMN.ColumnType
      .if eax == TYPE_EDITTEXT
            mov     eax, [esi]
         INVOKE     ListGetText, ebx, eax, lpData
      .else
            mov     eax, [esi]
            mov     edx, lpData
            mov     [edx], eax
      .endif
      INVOKE     GlobalUnlock, [ebx].LIST.hMem
         ret

ListGetCellData ENDP

ListSetCellData PROC uses ebx esi edi hMem:DWORD, rpData, nCol, lpData
LOCAL    len:DWORD

         mov     ebx, hMem
      INVOKE     GlobalLock, [ebx].LIST.hMem
         mov     esi, eax
         add     esi, rpData
         mov     eax, nCol
         lea     esi, [esi+eax*4]
         mov     edx, sizeof COLUMN
         mul     edx
         lea     edi, [ebx+eax+sizeof LIST]
         mov     eax, [edi].COLUMN.ColumnType
      .if eax == TYPE_EDITTEXT
           call     UpdateText
      .else
            mov     eax, lpData
            mov     eax, [eax]
            mov     [esi], eax
      .endif
      INVOKE     GlobalUnlock, [ebx].LIST.hMem
         ret

UpdateText:
      .if lpData
         INVOKE     lstrlen, lpData
            inc     eax
            mov     len, eax
            mov     eax, [ebx].LIST.rpStrFree
            add     eax, len
         .if eax>[ebx].LIST.StrMemSize
            INVOKE     ExpandMem, [ebx].LIST.hString, [ebx].LIST.StrMemSize
               mov     [ebx].LIST.hString, eax
               add     [ebx].LIST.StrMemSize, MEM_SIZE
         .endif
         INVOKE     GlobalLock, [ebx].LIST.hString
           push  eax
            mov     edx, eax
            mov     eax, [esi]
         .if eax
               add     edx, eax
            INVOKE     lstrlen, edx
               inc      eax
         .endif
            pop     edx
         .if eax>=len
               add     edx, [esi]
            INVOKE     lstrcpy, edx, lpData
         .else
               mov     ecx, [ebx].LIST.rpStrFree
               mov     [esi], ecx
               add     edx, ecx
               mov     eax, len
               add     [ebx].LIST.rpStrFree, eax
            INVOKE     lstrcpy, edx, lpData
         .endif
         INVOKE     GlobalUnlock, [ebx].LIST.hString
      .else
            xor     eax, eax
            mov     [esi], eax
      .endif
        retn

UpdateFixed:
      .if lpData
            mov     eax, [esi]
         .if !eax
               mov     eax, [ebx].LIST.rpStrFree
               mov     [esi], eax
               add     eax, ecx
            .if eax>[ebx].LIST.StrMemSize
               INVOKE     ExpandMem, [ebx].LIST.hString, [ebx].LIST.StrMemSize
                  mov     [ebx].LIST.hString, eax
                  add     [ebx].LIST.StrMemSize, MEM_SIZE
            .endif
         .endif
         INVOKE     GlobalLock, [ebx].LIST.hString
            mov     ecx, [edi].COLUMN.MaxLen
           push     esi
           push     edi
            mov     edi, eax
            add     edi, [esi]
            mov     esi, lpData
            rep     movsb
            pop     edi
            pop     esi
         INVOKE     GlobalUnlock, [ebx].LIST.hString
      .else
            xor     eax, eax
            mov     [esi], eax
      .endif
        retn

ListSetCellData ENDP

ListSort PROC uses ebx esi edi hMem:DWORD, lpLBMem, nCol, fString, fDescending
LOCAL    nVal:DWORD,  lpStrMem,  nStr

         mov     ebx, hMem
      .if fString
         INVOKE     GlobalLock, [ebx].LIST.hString
            mov     lpStrMem, eax
      .endif
      INVOKE     GlobalLock, [ebx].LIST.hMem
         mov     edi, nCol
         shl     edi, 2
         add     edi, eax
         mov     eax, [ebx].LIST.Rows
         dec     eax
      .if fString
         INVOKE     QuickSort, lpLBMem, 0, eax, edi, lpStrMem, fDescending
;         INVOKE     insertsort2, lpLBMem, 0, eax, edi, lpStrMem, fDescending
      .else
         INVOKE     QuickSort, lpLBMem, 0, eax, edi, 0, fDescending
;         INVOKE     insertsort2, lpLBMem, 0, eax, edi, 0, fDescending
      .endif
         mov     ebx, hMem
      INVOKE     GlobalUnlock, [ebx].LIST.hMem
      .if fString
         INVOKE     GlobalUnlock, [ebx].LIST.hString
      .endif
         ret

ListSort ENDP

ListSortColumn PROC uses ebx esi edi hMem:DWORD, nCol, nSort
LOCAL    Val:DWORD, Cnt01, Cnt02, Cnt03, Cnt04, ID

         mov     ebx, hMem
         mov     eax, [ebx].LIST.Rows
         shl     eax, 2
         mov     edi, eax
      INVOKE     HeapAlloc, hDefHeap, HEAP_ZERO_MEMORY, 10
         mov     hGrp01, eax
      INVOKE     HeapAlloc, hDefHeap, HEAP_ZERO_MEMORY, edi
         mov     hGrp02, eax
      INVOKE     HeapAlloc, hDefHeap, HEAP_ZERO_MEMORY, edi
         mov     hGrp03, eax
      INVOKE     HeapAlloc, hDefHeap, HEAP_ZERO_MEMORY, 256
         mov     hGrp04, eax

      INVOKE     GlobalAlloc, GMEM_FIXED, edi
         mov     esi, eax
         xor     ecx, ecx
      .while ecx < [ebx].LIST.Rows
           push     ecx
         INVOKE     SendMessage, [ebx].LIST.hList, LB_GETITEMDATA, ecx, 0
            pop     ecx
            mov     [esi+ecx*4], eax
            inc     ecx
      .endw

         mov     ecx, nCol
         mov     eax, sizeof COLUMN
         mul     ecx
         lea     edi, [ebx+eax+sizeof LIST]
         mov     eax, [edi].COLUMN.ColumnType
         xor     ecx, ecx
      .if eax == TYPE_EDITTEXT
            inc     ecx
      .endif
      .if nSort == SORT_ASCENDING || nSort == 3
            and     [edi].COLUMN.SortFlag, -1 xor 2
            xor     edx, edx
      .elseif nSort == SORT_DESCENDING || nSort == 4
             or     [edi].COLUMN.SortFlag, 2
            xor     edx, edx
            inc     edx
      .else
;---------- [Sort invert
            xor     [edi].COLUMN.SortFlag, 2
            mov     edx, [edi].COLUMN.SortFlag
            and     edx, 2
      .endif
         mov     eax, [edi].COLUMN.SortFlag
      .if eax
            mov     eax, 1
      .endif
         mov     [ebx].LIST.SortFlag, eax
      INVOKE     ListSort, ebx, esi, nCol, ecx, edx



         and     Cnt01, 0
         and     Cnt02, 0
         and     Cnt03, 0
         and     Cnt04, 0
         xor     ecx, ecx
      .while ecx < [ebx].LIST.Rows
            mov     edi, [esi+ecx*4]

;---------- [Fill the selection array from the current selections
;            mov     ID, ecx
           push     ecx
         INVOKE     ListGetCellData, ebx, edi, 5, addr Val
;            xor     edx, edx
;            mov     ecx, SelSortCnt
;           push     esi
;            mov     esi, LeftRight
;         .while (ecx)
;               mov     eax, SelSort[edx*4]
;            .if eax == edi
;                  mov     eax, ID
;DSPValue hWnd, eax, 1, 'm'
;DSPValue hWnd, edi, 1, 'm'
;                  mov     SelArray[esi+edx*4], eax
;            .endif
;               inc     edx
;               dec     ecx
;         .endw
;            pop     esi
;----------

            mov     eax, Val
         .if al == 1
               mov     edx, Cnt01
               mov     ecx, hGrp01
               mov     dword ptr[ecx+edx*4], edi
               inc     Cnt01
         .elseif al == 2
               mov     edx, Cnt02
               mov     ecx, hGrp02
               mov     dword ptr[ecx+edx*4], edi
               inc     Cnt02
         .elseif al == 3
               mov     edx, Cnt03
               mov     ecx, hGrp03
               mov     dword ptr[ecx+edx*4], edi
               inc     Cnt03
         .else
               mov     edx, Cnt04
               mov     ecx, hGrp04
               mov     dword ptr[ecx+edx*4], edi
               inc     Cnt04
         .endif
            pop     ecx
            inc     ecx
      .endw


         and     ID, 0
         xor     edi, edi
      .while (edi < Cnt01)
            mov     edx, hGrp01
            mov     eax, [edx+edi*4]
            mov     Val, eax
;            mov     [esi+ecx*4], eax
;           push     ecx
         .if nSort < 2 ;!= 2      ; Keep the directories in ascending seq
            INVOKE     SendMessage, [ebx].LIST.hList, LB_SETITEMDATA, ID, eax
              call     CheckSel
         .endif
;            pop     ecx
            inc     ID
            inc     edi
      .endw
         xor     edi, edi
      .while (edi < Cnt02)
            mov     edx, hGrp02
            mov     eax, [edx+edi*4]
            mov     Val, eax
;            mov     [esi+ecx*4], eax
;           push     ecx
         .if nSort < 2 ;!= 2      ; Keep the directories in ascending seq
            INVOKE     SendMessage, [ebx].LIST.hList, LB_SETITEMDATA, ID, eax
              call     CheckSel
         .endif
;            pop     ecx
            inc     ID
            inc     edi
      .endw
         xor     edi, edi
      .while (edi < Cnt03)
            mov     edx, hGrp03
            mov     eax, [edx+edi*4]
            mov     Val, eax
;            mov     [esi+ecx*4], eax
;           push     ecx
         INVOKE     SendMessage, [ebx].LIST.hList, LB_SETITEMDATA, ID, eax
;            pop     ecx
           call     CheckSel
            inc     ID
            inc     edi
      .endw
         xor     edi, edi
      .while (edi < Cnt04)
            mov     edx, hGrp04
            mov     eax, [edx+edi*4]
            mov     Val, eax
;            mov     [esi+ecx*4], eax
;           push     ecx
         INVOKE     SendMessage, [ebx].LIST.hList, LB_SETITEMDATA, ID, eax
;            pop     ecx
           call     CheckSel
            inc     ID
            inc     edi
      .endw

      INVOKE     GlobalFree, esi
      INVOKE     HeapFree, hDefHeap, 0, hGrp01
      INVOKE     HeapFree, hDefHeap, 0, hGrp02
      INVOKE     HeapFree, hDefHeap, 0, hGrp03
      INVOKE     HeapFree, hDefHeap, 0, hGrp04
         ret

CheckSel:
         xor     edx, edx
         mov     ecx, SelSortCnt
        push     esi
         mov     esi, LeftRight
         mov     esi, SelArray[esi]
      .while (ecx)
            mov     eax, SelSort[edx*4]
         .if eax == Val ;edi
               mov     eax, ID
               mov     [esi+edx*4], eax
         .endif
            inc     edx
            dec     ecx
      .endw
         pop     esi
        retn

ListSortColumn ENDP

