
.code

;=====================================================================
; Set handles
;=====================================================================
SetHandles PROC lpHandles:DWORD

         mov     edx, lpHandles
         mov     eax, [edx].HANDLES.hWnd
         mov     hWnd, eax
         mov     eax, [edx].HANDLES.hWndStat
         mov     hWndStat, eax
         mov     eax, [edx].HANDLES.hWndListL
         mov     hWndListLP, eax
         mov     eax, [edx].HANDLES.hWndListR
         mov     hWndListRP, eax
         mov     eax, [edx].HANDLES.hWndTree
         mov     hWndTree, eax
         mov     eax, [edx].HANDLES.hImageList
         mov     hImageList, eax

         ret

SetHandles ENDP

;=====================================================================
; Set colors
;=====================================================================
SetColors PROC Mem:DWORD, lpColors

         mov     ebx, Mem
         mov     ecx, lpColors
         mov     eax, [ecx].COLORS.ColumnBC
         mov     [ebx].LIST.ColumnBack, eax
         mov     eax, [ecx].COLORS.ListBC
         mov     [ebx].LIST.ListBack, eax
         mov     eax, [ecx].COLORS.Grid
         mov     [ebx].LIST.ListGrid, eax
         mov     eax, [ecx].COLORS.Selection
         mov     [ebx].LIST.Selback, eax
         mov     eax, [ecx].COLORS.SelInactive
         mov     [ebx].LIST.SelInactive, eax
         mov     eax, [ecx].COLORS.ColumnTC
         mov     [ebx].LIST.ColumnText, eax
         mov     eax, [ecx].COLORS.ListTC
         mov     [ebx].LIST.ListText, eax

         ret

SetColors ENDP


;=====================================================================
; Converts a Dec, Hex, Oct or Bin ascii string to a 32 bit num value.
;=====================================================================
AsciiBase PROC Input:DWORD, Output, Base

      pushad
         mov     esi, Input
         mov     edi, Output
         and     dword ptr[edi], 0
      INVOKE     lstrlen, Input
         xor     edx, edx

      .if byte ptr[esi] == '-'
            mov     edx, -1
            mov     byte ptr[esi], '0'
      .endif

         xor     ecx, ecx
      .while (eax)
         .if byte ptr[esi+ecx] > 60h
               sub     byte ptr[esi+ecx], 57h
         .elseif byte ptr[esi+ecx] > 40h
               sub     byte ptr[esi+ecx], 37h
         .else
               xor     byte ptr[esi+ecx], 30h
         .endif
            dec     eax
            inc     ecx
      .endw
         mov     ebx, 1
         mov     esi, Input
         add     esi, ecx
         dec     esi
      .while (ecx)
            mov     al, byte ptr[esi]      ; Extract byte for conversion
            and     eax, 000000ffh
           imul     eax, ebx
            add     dword ptr[edi], eax    ; Accumulate output
           imul     ebx, Base
            dec     esi
            dec     ecx 
      .endw
      .if sdword ptr edx < 0                ; Negate if minus
            neg     dword ptr[edi]
      .endif
       popad

         ret
AsciiBase ENDP

;=========================================================================
;  Converts a 32 bit num value to a Dec, Hex, Oct or Bin ascii string.
;=========================================================================
;INVOKE     BaseAscii, cnt, offset num, 2, 10, 0, 1, 0
BaseAscii PROC InPut:DWORD, OutPut, LEN, Base, Comma, Fill, TermA
LOCAL    LBuff[32]: BYTE

      pushad
         xor     esi, esi
         mov     eax, InPut                ; Input
         mov     ebx, OutPut
         mov     byte ptr [ebx], '0'

;      .if sdword ptr eax < 0               ; Check for negative number
;            mov     byte ptr [ebx], '-'    ; Store a minus sign
;            inc     ebx
;            neg     eax                    ; and invert the value
;      .endif

      .while (eax)
            xor     edx, edx
            div     Base                   ; Base 10, 16, 8, 2
         .if dl > 9h
               add     dl, 37h             ; Convert to hex ASCII
         .else
               add     dl, 30h             ; Convert to dec ASCII
         .endif
            mov     LBuff[esi], dl
            inc     esi
         .if Comma == 1 && Base == 10 && eax > 0
            .if esi == 3 || esi == 7 || esi == 11
                  mov     LBuff[esi], 2ch  ; Insert commas
                  inc     esi
            .endif
         .endif
      .endw
         xor     edi, edi
         mov     ecx, esi
      .if LEN > ecx && Fill == 1           ; Zero fill
            xor     eax, eax
         .while (eax < LEN)
               mov     byte ptr [ebx+eax], '0'
               inc     eax
         .endw
            sub     LEN, ecx
            add     edi, LEN
      .endif
      .while (ecx)
            mov     al, byte ptr LBuff[esi-1]
            mov     byte ptr [ebx+edi], al
            inc     edi
            dec     esi
            dec     ecx
      .endw
      .if TermA
         mov     byte ptr [ebx+edi], 0h
      .endif
       popad
         ret

BaseAscii ENDP
